#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_S5"]
	#Text["RGB Danmaku Gamer Set [r] A spell card full of color and neon lights"]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
	
	@Initialize{
		SetAutoDeleteObject(true);
		let objScene = GetEnemyBossSceneObjectID();
		ObjEnemyBossScene_StartSpell(objScene);
		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		movement;
		renderBoss(1);
		TEnd;
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets upon appearance	
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(12000);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(120);
		}
		case(EV_REQUEST_SPELL_SCORE) {
			SetScriptResult(200000);
		}
	}
	
	task movement{
		Cutin(objEnemy,"RGB Danmaku Gamer Set",1);
		let B = 90;
		let C = 60;
		let C2 = C/2;
		let X = 0;
		let Y = 0;
			X=GetClipMaxX/2+C*sin(B);
			Y=GetClipMaxY/4-C2*cos(B);
			B+=6;
			ObjMove_SetDestAtFrame(objEnemy,X,Y,60);
		wait(60);
		Fire;
		loop{
			X=GetClipMaxX/2+C*sin(B);
			Y=GetClipMaxY/4-C2*cos(B);
			B+=6;
			ObjMove_SetDestAtFrame(objEnemy,X,Y,6);
			wait(6);
		}
	}
	
	task Fire{
		let B = 90;
		let color = 148;
			PlaySound(PowerUp);
			loop(30){
				TChargeEffect(ex, ey,1);
				wait(2);
			}
		loop{
			PlaySound(Twinkle3);
			
			loop(1){
				ShootShape(ex,ey, 1.5, B, 3, 4, color, 6);
				B+=1.6*2.4;
				wait(3);
			}
			color+=2;
			if(color>=162){color = 148;}
				if(ObjEnemy_GetInfo(objEnemy, INFO_LIFE)<= 8000){
					Fire2;
					DeleteShotAll(TYPE_ALL, TYPE_ITEM);
					break;
				}
			yield;
		}
	}
	
	task Fire2{
		loop(5){TExplodeEffect(ex,ey,1);}
		let B = 90;
		let color = 148;
			PlaySound(PowerUp);
			loop(30){
				TChargeEffect(ex, ey,1);
				wait(2);
			}
		loop{
			PlaySound(Twinkle3);
			
			loop(1){
				ShootShape(ex,ey, 1.5, B, 4, 4, color, 6);
				B+=1.6*2.5;
				wait(3);
			}
			color+=2;
			if(color>=162){color = 148;}
				if(ObjEnemy_GetInfo(objEnemy, INFO_LIFE)<= 4000){
					Fire3;
					DeleteShotAll(TYPE_ALL, TYPE_ITEM);
					break;
				}
			yield;
		}
	}
	task Fire3{
		loop(5){TExplodeEffect(ex,ey,1);}
		let B = 90;
		let color = 148;
			PlaySound(PowerUp);
			loop(30){
				TChargeEffect(ex, ey,1);
				wait(2);
			}
		loop{
			PlaySound(Twinkle3);
			
			loop(1){
				ShootShape(ex,ey, 1.5, B, 6, 3, color, 6);
				B+=1.6*2.6;
				wait(3);
			}
			color+=2;
			if(color>=162){color = 148;}
			yield;
		}
	}
	
	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}

		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		loop(15){TExplodeEffect(ex,ey,1);}
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}